#IMAGE_LoadSave = 0
#IMAGE_Convert = 1
#winConvertTileset =0
Enumeration
    #GADGET_WTileFr1
  #GADGET_WTileFr2
  #GADGET_WTileTxt
  #GADGET_WTileTxt2
  #GADGET_WTileTxt3
  #GADGET_WTileW
  #GADGET_WTileH
  #GADGET_WTileWmax
  #GADGET_WTileHmax
  #GADGET_WTileConstraint
  #GADGET_WTilebtnOk
  #GADGET_WTilebtnCancel
  #GADGET_WTileNewImg
  #GADGET_WTilePos
EndEnumeration

UseJPEGImageDecoder()
UseJPEGImageEncoder()
UsePNGImageDecoder()
UsePNGImageEncoder()

File$ = OpenFileRequester("Load Image...", "", "PNG Images|*.png|JPEG Images|*.jpeg|All Files|*.*", 0)
If File$
  If LoadImage(#IMAGE_LoadSave, File$)     
    If OpenWindow(#winConvertTileset,0,0,400,300,"Convert to TileSet",#PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_SizeGadget)
      dee.a= 110
      dh.a=10
      ; variables
      Define tileH.w=32,tileW.w=32,tileWmax.a = 10
      imgW = ImageWidth(#IMAGE_LoadSave)
      imgH = ImageHeight(#IMAGE_LoadSave)
      ;{ gadgets
      If Frame3DGadget(#GADGET_WTileFr1,10,10,dee + 60,120,"Export Dimension")         
        txt1$="Width :"
        txt2$="Height :"
        TextGadget(#GADGET_WTileTxt,dee-Len(txt1$)*5,dh+22,120,20,txt1$)
        TextGadget(#GADGET_WTileTxt2,dee-Len(txt2$)*5,dh+52,120,20,txt2$)
       
        SpinGadget(#GADGET_WTileW,dee,dh+20,50,20,1,256,#PB_Spin_Numeric)
        SpinGadget(#GADGET_WTileH,dee,dh+50,50,20,1,256,#PB_Spin_Numeric)
       
        SetGadgetState(#GADGET_WTileW,tileW)
        SetGadgetState(#GADGET_WTileH,tileH)
        SpinGadget(#GADGET_WTileWmax,dee+20,dh+80,30,20,1,50,#PB_Spin_Numeric)
        SetGadgetState(#GADGET_WTileWmax,tileWmax)
        txt3$="Export Width : "+Str(GetGadgetState(#GADGET_WTileWmax)* Val(GetGadgetText(#GADGET_WTileW)))
        TextGadget(#GADGET_WTileTxt3,dee-Len(txt3$)*5,dh+82,100,20,txt3$)
       
      EndIf
      If Frame3DGadget(#GADGET_WTileFr2,10,140,dee+60,120,"Options")
        CheckBoxGadget(#GADGET_WTileConstraint,20,160,130,20,"Constraint Proportion")
        proportion = 1
        SetGadgetState(#GADGET_WTileConstraint,proportion)                   
        CheckBoxGadget(#GADGET_WTileNewImg,20,180,130,20,"Create a New image")
        NewImg = 1
        SetGadgetState(#GADGET_WTileNewImg,NewImg)   
        ComboBoxGadget(#GADGET_WTilePos,20,200,130,20)
        AddGadgetItem(#GADGET_WTilePos,0,"Begining of the image")
        AddGadgetItem(#GADGET_WTilePos,1,"End of the image")
       
        ;ScrollAreaGadget(#GADGET_wTileScroll,
      EndIf
      ButtonGadget(#GADGET_WTilebtnOk,dee+30,270,60,20,"OK")
      ButtonGadget(#GADGET_WTilebtnCancel,dee+100,270,60,20,"Cancel")
      ;}
    EndIf
   
    Repeat     
      event = WaitWindowEvent(10)     
      Select event
         
        Case #PB_Event_Gadget
         
          Select EventGadget()
              ;{ autres gadgets
            Case #GADGET_WTileConstraint               
              proportion = GetGadgetState(#GADGET_WTileConstraint)
             
            Case #GADGET_WTileNewImg
              NewImg = GetGadgetState(#GADGET_WTileNewImg)
             
            Case #GADGET_WTileW, #GADGET_WTileWmax, #GADGET_WTileH
              If proportion = 1
                If EventGadget() = #GADGET_WTileW                 
                  SetGadgetState(#GADGET_WTileH,GetGadgetState(#GADGET_WTileW))                                 
                ElseIf EventGadget() = #GADGET_WTileH
                  SetGadgetState(#GADGET_WTileW,GetGadgetState(#GADGET_WTileH))   
                EndIf
              EndIf
              tileH=GetGadgetState(#GADGET_WTileH)
              tileW=GetGadgetState(#GADGET_WTileW)
              tileWmax = GetGadgetState(#GADGET_WTileWmax)
              txt3$="Export Width : "+Str(tileWmax* tileH)
              SetGadgetText(#GADGET_WTileTxt3,txt3$)
              ;}
             
            Case #GADGET_WTilebtnOk
             
              totalpixel = imgW * imgH               
              newImgH = Round(totalpixel/(tileWmax * tileW),1)          
              NbrImgNew = (Round(imgW/tileW,1)+1) * (Round(imgH/TileH,1)+1)    
              Dim imgdecoup(NbrImgNew)
             
              a=0
              For j = 0 To imgH/tileH-1           
                For i = 0 To imgW/tileW-1
                  imgdecoup(a) = GrabImage(#IMAGE_LoadSave, #PB_Any, i*tileW, j*tileH, tileW, tileH)
                  a+1                   
                Next i             
              Next  j
              If NewImg                 
                a=0               
                CreateImage(#IMAGE_Convert,tileWmax*tileW,newImgH,32|#PB_Image_Transparent)
                StartDrawing(ImageOutput(#IMAGE_Convert))                 
                For j = 0 To Round(newImgH/tileH,1)
                  For i = 0 To tileWmax-1                                     
                    DrawAlphaImage(ImageID(imgdecoup(a)),i*tileW,j* tileH)
                    a+1                   
                  Next i
                Next  j                 
                StopDrawing()
                File$ = SaveFileRequester("Save Image...", File$, "PNG Images|*.png|JPEG Images|*.jpeg|BMP Images|*.bmp", 0)
                If File$ And (FileSize(File$) = -1 Or MessageRequester("Save an image", "Overwrite this file? " + File$, #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes)
                  If SelectedFilePattern() = 0 ; png
                    If SaveImage(#IMAGE_Convert, RemoveString(File$,".png")+".png", #PB_ImagePlugin_PNG) = 0
                      MessageRequester("Save Image", "Cannot save image: " + File$)
                    EndIf
                  ElseIf SelectedFilePattern() = 1 ; jpg
                    If SaveImage(#IMAGE_Convert, RemoveString(File$,".jpg")+".jpg", #PB_ImagePlugin_JPEG) = 0
                      MessageRequester("Save Image", "Cannot save image: " + File$)
                    EndIf
                  ElseIf SelectedFilePattern() = 2 ; bmp
                    If SaveImage(#IMAGE_Convert, RemoveString(File$,".bmp")+".bmp", #PB_ImagePlugin_BMP) = 0
                      MessageRequester("Save Image", "Cannot save image: " + File$)
                    EndIf
                  EndIf
                  FreeImage(#IMAGE_Convert)
                  FreeImage(#IMAGE_LoadSave)
                  FreeArray(imgdecoup())
                  quit = 1
                EndIf     
              Else
                MessageRequester("","Sorry, not coed for the moment, choose 'new image' as option")
              EndIf
             
            Case #GADGET_WTilebtnCancel
              quit = 1
             
          EndSelect
                   
        Case #PB_Event_CloseWindow
          If GetActiveWindow() = #winConvertTileset
            quit = 1
          EndIf
      EndSelect
           
    Until quit = 1
    CloseWindow(#winConvertTileset)   
  EndIf
EndIf
; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 163
; FirstLine = 67
; Folding = 9
; EnableXP
; EnableOnError
; EnablePurifier